summaryrefslogtreecommitdiff
path: root/source/e/emacs
diff options
context:
space:
mode:
Diffstat (limited to 'source/e/emacs')
-rwxr-xr-xsource/e/emacs/emacs.SlackBuild10
-rw-r--r--source/e/emacs/emacs.glibc-2.34.patch40
2 files changed, 48 insertions, 2 deletions
diff --git a/source/e/emacs/emacs.SlackBuild b/source/e/emacs/emacs.SlackBuild
index a25b27b3..33a31cea 100755
--- a/source/e/emacs/emacs.SlackBuild
+++ b/source/e/emacs/emacs.SlackBuild
@@ -27,7 +27,7 @@
cd $(dirname $0) ; CWD=$(pwd)
PKGNAM=emacs
-BUILD=${BUILD:-1}
+BUILD=${BUILD:-2}
# Determine version number the tarball is labeled with:
TARBALLVER=${TARBALLVER:-$(echo $PKGNAM-*.tar.xz | rev | cut -f 3- -d . | cut -f 1 -d - | rev)}
# OK, now what's being used as the source directory version number... account
@@ -99,7 +99,7 @@ find . \
# memory given the amount available on modern systems:
sed -i "s/#define SYSTEM_PURESIZE_EXTRA 0/#define SYSTEM_PURESIZE_EXTRA 100000/g" src/puresize.h
-#autoreconf -vif
+zcat $CWD/emacs.glibc-2.34.patch.gz | patch -p1 --verbose || exit 1
CFLAGS="$SLKCFLAGS" \
CXXFLAGS="$SLKCFLAGS" \
@@ -140,6 +140,12 @@ find . \
\( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
-exec chmod 644 {} \+
+# The defaults are a little too worried about adding a few more K of pure
+# memory given the amount available on modern systems:
+sed -i "s/#define SYSTEM_PURESIZE_EXTRA 0/#define SYSTEM_PURESIZE_EXTRA 100000/g" src/puresize.h
+
+zcat $CWD/emacs.glibc-2.34.patch.gz | patch -p1 --verbose || exit 1
+
CFLAGS="$SLKCFLAGS" \
CXXFLAGS="$SLKCFLAGS" \
./configure \
diff --git a/source/e/emacs/emacs.glibc-2.34.patch b/source/e/emacs/emacs.glibc-2.34.patch
new file mode 100644
index 00000000..6d764aa2
--- /dev/null
+++ b/source/e/emacs/emacs.glibc-2.34.patch
@@ -0,0 +1,40 @@
+From f97e07ea807cc6d38774a3888a15091b20645ac6 Mon Sep 17 00:00:00 2001
+From: Paul Eggert <eggert@cs.ucla.edu>
+Date: Tue, 9 Mar 2021 11:22:59 -0800
+Subject: [PATCH] Port alternate signal stack to upcoming glibc 2.34
+MIME-Version: 1.0
+Content-Type: text/plain; charset=UTF-8
+Content-Transfer-Encoding: 8bit
+
+* src/sysdep.c (sigsegv_stack): Increase size to 64 KiB and align
+it to max_align_t. This copies from Gnulib’s c-stack.c, and works
+around a portability bug in draft glibc 2.34, which no longer
+defines SIGSTKSZ when _GNU_SOURCE is defined.
+---
+ src/sysdep.c | 10 +++++++++-
+ 1 file changed, 9 insertions(+), 1 deletion(-)
+
+diff --git a/src/sysdep.c b/src/sysdep.c
+index 941b4e2fa2..24d8832b2f 100644
+--- a/src/sysdep.c
++++ b/src/sysdep.c
+@@ -1785,7 +1785,15 @@ handle_arith_signal (int sig)
+
+ /* Alternate stack used by SIGSEGV handler below. */
+
+-static unsigned char sigsegv_stack[SIGSTKSZ];
++/* Storage for the alternate signal stack.
++ 64 KiB is not too large for Emacs, and is large enough
++ for all known platforms. Smaller sizes may run into trouble.
++ For example, libsigsegv 2.6 through 2.8 have a bug where some
++ architectures use more than the Linux default of an 8 KiB alternate
++ stack when deciding if a fault was caused by stack overflow. */
++static max_align_t sigsegv_stack[(64 * 1024
++ + sizeof (max_align_t) - 1)
++ / sizeof (max_align_t)];
+
+
+ /* Return true if SIGINFO indicates a stack overflow. */
+--
+2.29.2
+